
if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
   if(!$RTB::RTBR_ServerControl_Hook)
      exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
   RTB_registerPref("Maximum Weapons","Multi Slots Player","MultiSlotPlayer::Slots","int 1 9","Player_MultipleSlotsMore",8,1,1);
}
else
{
   $MultiSlotPlayer::Slots = 8;
}

datablock PlayerData(PlayerMultiSlotNoJetFirstPersonArmor : PlayerStandardArmor)
{
	canJet = 0;
	firstPersonOnly=1;
	uiName = $MultiSlotPlayer::Slots @ "-Slot Player No Jet (FP)";
	maxTools = $MultiSlotPlayer::Slots;
	maxWeapons = $MultiSlotPlayer::Slots;
};
PlayerMultiSlotNoJetFirstPerson.maxForwardSpeed*=1.05;
PlayerMultiSlotNoJetFirstPerson.maxBackwardSpeed*=1.05;
PlayerMultiSlotNoJetFirstPerson.maxSideSpeed*=1.05;

$DefaultClimbable = 1;
package Agility
{
	function Armor::onTrigger(%db,%player,%slot,%io)
	{
		Parent::onTrigger(%db,%player,%slot,%io);

		if(%player.getDatablock().canClimb)
		{
			if(%slot == 4)
			{
				%player.pkm = %io;
			}
			if(!%player.getMountedImage(0) || !%player.getDatablock().alwaysClimb)
			{
				%side = %player.getDatablock().wallJumpVel;
				%up = %player.getDatablock().wallClimbVel;
				if(%slot == 2 && %io)
				{
					if(%player.holding)
					{
						%up = %side;
						%side += 4;
						%dir = %player.getEyeVector();
						%player.holding = 0;
						cancel(%player.nhtick);
						%player.holdposition = "";
						%vel = mClampF(getword(%dir,0) * %side,0 - %side,%side) SPC mClampF(getword(%dir,1) * %side,0 - %side,%side) SPC mClampF(getword(%dir,2) * %up,0 - %up,%up);
						%player.setVelocity(%vel);
						return;
					}
					%touch = containerRayCast(%player.getPosition(),vectorAdd(vectorScale(vectorNormalize(setword(%player.getEyeVector(),2,"0")),2),%player.getPosition()),$TypeMasks::FxBrickAlwaysObjectType|$TypeMasks::InteriorObjectType);
					if(!isObject(%touch))
					{
						return;
					}
					if(%touch.getClassName() $= "InteriorInstance")
					{
						%col = 1;
					} else {
						%col = %touch.isColliding();
					}
					if(isObject(%touch) && %col && (%touch.rejClimb == !$DefaultClimbable))
					{
						if(%player.pkm)
						{
							if(%touch.getClassName() $= "fxDTSBrick")
							{
								%touch.onClimb(%player);
							}
							%dir = %player.getEyeVector();
							if(getWord(%dir,2) > 0)
							{
								%player.setVelocity("0 0" SPC %up);
							} else {
								%vel = mClampF(getword(%dir,0) * (0 - %side),0 - %side,%side) SPC mClampF(getword(%dir,1) * (0 - %side),0 - %side,%side) SPC %up;
								%player.setVelocity(%vel);
							}
							%player.playThread(2,"activate2");
						}
					}
				}
				if(%slot == 0)
				{
					if(%io)
					{
						%touch = containerRayCast(%player.getPosition(),vectorAdd(vectorScale(vectorNormalize(setword(%player.getEyeVector(),2,"0")),2),%player.getPosition()),$TypeMasks::FxBrickAlwaysObjectType|$TypeMasks::InteriorObjectType);
						if(!isObject(%touch))
						{
							return;
						}
						if(%touch.getClassName() $= "InteriorInstance")
						{
							%col = 1;
						} else {
							%col = %touch.isColliding();
						}
						if(isObject(%touch) && %col && (%touch.rejClimb == !$DefaultClimbable))
						{
							if(%player.pkm)
							{
								if(!%player.Holding)
								{
									%player.HoldPosition = %player.getPosition();
									%player.nhtick = schedule(100,0,"HoldTick",%player);
									%player.holding = 1;
									%player.PlayThread(1,"armReady");
								} else {
									%player.holding = 0;
									cancel(%player.nhtick);
									%player.holdposition = "";
								}
							}
						}
					}
				}
			}
		}
	}
	function Player::ActivateStuff(%player)
	{
		if(%player.pkm)
		{
			return;
		}
		Parent::ActivateStuff(%player);
	}
};
ActivatePackage(Agility);
function fxDTSBrick::setClimbable(%brick,%bool)
{
	if($DefaultClimbable)
	{
		%brick.rejClimb = !%bool;
	} else {
		%brick.rejClimb = %bool;
	}
}
registerOutputEvent(fxDTSBrick,"setClimbable","bool",0);
function fxDTSBrick::onClimb(%brick,%player)
{
	$inputTarget_Self = %brick;
	$inputTarget_Player = %player;
	$inputTarget_Client = %player.client;
	%brick.processInputEvent("onClimb",%player.client);
}
registerInputEvent(fxDTSBrick,"onClimb","Self fxDTSBrick\tPlayer Player\tClient GameConnection");

function HoldTick(%player)
{
	if(!isObject(%player))
	{
		return;
	}
	cancel(%player.nhtick);
	if(%player.pkm && %player.holding)
	{
		%player.setTransform(%player.HoldPosition);
		%player.setVelocity("0 0 2");
		%player.nhtick = schedule(100,0,"HoldTick",%player);
	} else {
		%player.holdPosition = "";
	}
}

datablock PlayerData(PlayerAgileMultiSlot : PlayerStandardArmor)
{
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;
	maxTools = $MultiSlotPlayer::Slots;
	maxWeapons = $MultiSlotPlayer::Slots;
	maxForwardSpeed = 16;
	maxBackwardSpeed = 12;
	maxSideSpeed = 12;

	maxForwardCrouchSpeed = 10;
	maxBackwardCrouchSpeed = 7;
	maxSideCrouchSpeed = 7;

	maxDamage = 100;

	canClimb = 1;
	alwaysClimb = 0;
	wallJumpVel = 12;
	wallClimbVel = 12;

	airControl = 0.15;
	speedDamagescale = 1.9;

	uiName = $MultiSlotPlayer::Slots @ "-Slot Agile Player";
};

function HealthAgilePlayerCheck()
{
	if(isPackage("HealthMode_Package"))
	{
		datablock PlayerData(PlayerAgileHealthMultiSlot : PlayerAgile)
		{
			maxDamage = 1;
			maxEnergy = 100;
			showEnergyBar = 1;
			isHealthPlayer = 1;
			rechargeRate = 0.01;
			maxTools = $MultiSlotPlayer::Slots;
			maxWeapons = $MultiSlotPlayer::Slots;


			uiName = $MultiSlotPlayer::Slots @ "Agile Health Player";
		};
	}
}
schedule(250,0,"HealthAgilePlayerCheck");

//Setting the support so we can see all Slots
package InventorySlotAdjustment
{
	function Armor::onNewDatablock(%data,%this)
	{
		Parent::onNewDatablock(%data,%this);
		if(isObject(%this.client))
		{
			commandToClient(%this.client,'PlayGui_CreateToolHud',%data.maxTools);
			for(%i=0;%i<%data.maxTools;%i++)
			{
				if(isObject(%this.tool[%i]))
					messageClient(%this.client,'MsgItemPickup',"",%i,%this.tool[%i].getID(),1);
				else
					messageClient(%this.client,'MsgItemPickup',"",%i,0,1);
			}
		}
	}
	function GameConnection::setControlObject(%this,%obj)
	{
		Parent::setControlObject(%this,%obj);
		if(%obj == %this.player)
			commandToClient(%this,'PlayGui_CreateToolHud',%obj.getDatablock().maxTools);
	}
	function Player::changeDatablock(%this,%data,%client)
	{
		if(%data != %this.getDatablock())
			commandToClient(%this.client,'PlayGui_CreateToolHud',%data.maxTools);
		Parent::changeDatablock(%this,%data,%client);
	}
};
activatePackage(InventorySlotAdjustment);